> For the complete documentation index, see [llms.txt](https://docs.rowsncolumns.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rowsncolumns.app/configuration/features/calculate-on-demand.md).

# Calculate on-demand

If you are uploading an excel file or replacing the state of the spreadsheet, you will have to manually trigger a full recalc.

You can also disable formula evaluation or reset teh cell dependency graph using options.

To do so, `useSpreadsheetState` exposes `calculateNow` function.

{% code overflow="wrap" %}

```tsx
import {
  SpreadsheetProvider,
  CanvasGrid,
} from "@rowsncolumns/spreadsheet";
import { useSpreadsheetState } from "@rowsncolumns/spreadsheet-state";

const MySpreadsheet = () => {
  const { calculateNow } = useSpreadsheetState({
    ...
  });
  return (
    <div>
      <input type="file" onChange={() => {
        // Update sheets
        // update sheet Data
        // Update table
        calculateNow({
          // Formulas are not evaluated, only cell dependency graph is rebuilt
          disableEvaluation: true,
          // Optionally reset the entire dependency graph
          resetDependencyGraph: true,
        })
      })
      <CanvasGrid />
    </div>
  );
};

const App = () => (
  <SpreadsheetProvider>
    <MySpreadsheet />
  </SpreadsheetProvider>
);
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.rowsncolumns.app/configuration/features/calculate-on-demand.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
